import "escape.clp".
import "../smemory/memory.clp".
import "../smemory/aliasing_full.clp".
import "../smemory/scalar_sat.clp".

analyze session_name("cil_sum_body").
analyze analysis_name("funptr_refine").

% OUTPUT

predicate str_indirect_context(FN:string,CXT:t_call_context,
                               I:string,CFN:string).
?- str_indirect_context(FN,CXT,I,CFN).

% RULES

predicate add_refine_indirect(CXT:t_call_context,I:c_instr,CFN:string).
cil_curfn(FN), add_refine_indirect(CXT,I,CFN),
    +sum_funptr_refine(FN)->sindirect_context(I,CXT,CFN),
    cil_instr_call(I,E), exp_string(E,CALL),
    +str_indirect_context(FN,CXT,CALL,CFN).

predicate try_funptr_escape(FT:t_trace,CXT:t_call_context).
predicate funptr_escape(FT:t_trace,CXT:t_call_context,FNPTRS:set[string]).

try_funptr_escape(FT,CXT),
    cil_curfn(FN), one_reduce_trace_loc(FN,FT,CXT,L),
    (Y=es_backward_precise{ep_field{1}};
     Y=es_backward_precise{ep_field{2}};
     Y=es_backward_precise{ep_field{4}};
     Y=es_backward),
    +try_escape(100,Y,L),
    ~escape_fail(100,Y,L),
    \/escape(100,Y,L,
             tl_glob{root{glob{FNPTR}}}):set_all(FNPTR,FNPTRS),
    +funptr_escape(FT,CXT,FNPTRS).

predicate try_context(in T:t_trace,LEVELS:int).
+try_context(_,0).
try_context(T,1) :- trace_root(T,arg{_}),
    ~(trace_sub(T,fld{STR,_,_},_), trace_sub(STR,fld{_,_,_},_)).

cil_curfn("kernel/sys.c:notifier_call_chain"), +try_context(_,2).

predicate fill_context(in FN:string,in LEVELS:int,CXT:t_call_context).
+fill_context(_,0,cxt_any).
fill_context(FN,LEVELS,cxt_call{PFN,PI,PCXT}) :- int_gt(LEVELS,0),
    cil_sum_caller(FN,s_func)->caller(PFN,_,_,s_call{PI}),
    int_sub(LEVELS,1,NLEVELS), fill_context(PFN,NLEVELS,PCXT).

predicate use_context(in T:t_trace,CXT:t_call_context).
use_context(T,CXT) :- \/try_context(T,XLV):int_max_all(XLV,LEVELS),
    cil_curfn(FN), fill_context(FN,LEVELS,CXT).

predicate fnptr_eval(in P:pp,in E:c_exp,FT:t_trace,CXT:t_call_context).
fnptr_eval(P,E,T,CXT) :- eval(P,E,s_trace{drf{XT}},_),
    reduce_trace_skolem(XT,T), use_context(T,CXT).

icall(P,_,I), ~dircall(I,_), cil_instr_call(I,FNE),
    fnptr_eval(P,FNE,FNT,CXT), +try_funptr_escape(FNT,CXT).

icall(P,_,I), ~dircall(I,_), cil_instr_call(I,FNE),
    ~(fnptr_eval(P,FNE,NXT,XCXT), ~funptr_escape(NXT,XCXT,_)),
    fnptr_eval(P,FNE,FNT,CXT),
    \/funptr_escape(FNT,CXT,XFNPTRS):set_intersect_all(XFNPTRS,FNPTRS),
    set_member(FNPTRS,CFN), +add_refine_indirect(CXT,I,CFN).
