
% attributes

predicate str_attribute_received(FNPTR:string,AT:string,WFN:string,WSUM:sum,WT:string).
?- str_attribute_received(FNPTR,AT,WFN,WSUM,WT).

predicate attribute_receive(C:string,T:t_trace,FN:string,SUM:sum,P:pp,RT:t_trace).
attribute_receive(C,T,FN,SUM,P,RT), (FLD="show"; FLD="store"),
    L=tl_glob{drf{fld{T,FLD,C}}},
    escape_set(200,es_backward_precise{ep_maximum},L,LSET),
    set_member(LSET,tl_glob{root{glob{FNPTR}}}),
    AT=drf{root{arg{0}}},
    trace_string(AT,ATS), trace_string(RT,RTS),
    +str_attribute_received(FNPTR,ATS,FN,SUM,RTS),
    +spoly_receive_attribute(C,FLD,AT)->wpoly_receive(FNPTR,FN,SUM,P,RT).

predicate caller_global_trace(in I:c_instr,in CT:t_trace,GT:t_trace).
caller_global_trace(I,CT,GT) :- icall(P,_,I),
    inst_trace(s_call{I},P,CT,s_trace{AT},_),
    reduce_trace_skolem(AT,GT), trace_root(GT,glob{_}).

% attaching attributes to devices
dircall(I,"device_create_file"),
    caller_global_trace(I,drf{root{arg{1}}},AT),
    icall(P,_,I), inst_trace(s_call{I},P,drf{root{arg{0}}},s_trace{RT},_),
    cursum(FN,SUM), +attribute_receive("device_attribute",AT,FN,SUM,P,RT).

% the call to scsi_host_alloc indicates the attributes to use for the created host
dircall(I,"scsi_host_alloc"), icall(P,_,I), callret(P,I,RT,_),
    caller_global_trace(I,drf{root{arg{0}}},T),
    AT=drf{uk_index{drf{fld{T,"shost_attrs","scsi_host_template"}},
                    y_ptr{y_comp{"class_device_attribute"}}}},
    FRT=fld{uc_sum{s_call{I},P,RT},"shost_classdev","Scsi_Host"},
    cursum(FN,SUM), +attribute_receive("class_device_attribute",AT,FN,SUM,P,FRT).

% attaching attributes to disks -- no wrapper (e.g. aoedisk_add_sysfs)
dircall(I,"sysfs_create_file"),
    caller_global_trace(I,drf{root{arg{1}}},fld{AT,"attr","disk_attribute"}),
    icall(P,_,I), inst_trace(s_call{I},P,drf{root{arg{0}}},s_trace{fld{RT,"kobj","gendisk"}},_),
    cursum(FN,SUM), +attribute_receive("disk_attribute",AT,FN,SUM,P,RT).

% attaching attributes to class devices
dircall(I,"class_device_create_file"),
    caller_global_trace(I,drf{root{arg{1}}},AT),
    icall(P,_,I), inst_trace(s_call{I},P,drf{root{arg{0}}},s_trace{RT},_),
    cursum(FN,SUM), +attribute_receive("class_device_attribute",AT,FN,SUM,P,RT).

% attaching attribute groups to class devices -- no wrapper (e.g. br_sysfs_addbr)
dircall(I,"sysfs_create_group"),
    caller_global_trace(I,drf{root{arg{1}}},T),
    icall(P,_,I), inst_trace(s_call{I},P,drf{root{arg{0}}},s_trace{fld{RT,"kobj","class_device"}},_),
    AT=rfld{drf{uk_index{drf{fld{T,"attrs","attribute_group"}},
                         y_ptr{y_comp{"attribute"}}}},"attr","class_device_attribute"},
    cursum(FN,SUM), +attribute_receive("class_device_attribute",AT,FN,SUM,P,RT).
+ignore_escape_function("sysfs_create_group").
+ignore_escape_function("sysfs_remove_group").

% attaching attributes to video devices (subset of class devices)
dircall(I,"include/linux/videodev.h:video_device_create_file"),
    caller_global_trace(I,drf{root{arg{1}}},AT),
    icall(P,_,I), inst_trace(s_call{I},P,fld{drf{root{arg{0}}},"class_dev","video_device"},s_trace{RT},_),
    cursum(FN,SUM), +attribute_receive("class_device_attribute",AT,FN,SUM,P,RT).

% attaching attributes to elevator data. the elevator has not been created yet
% when this call occurs so just attach to the argument passed to the exit function
% in the elevator_ops
dircall(I,"elv_register"),
    caller_global_trace(I,drf{root{arg{0}}},T),
    AT=uk_index{drf{fld{T,"elevator_attrs","elevator_type"}},
                y_comp{"elv_fs_entry"}},
    EXITT=drf{fld{fld{T,"ops","elevator_type"},"elevator_exit_fn","elevator_ops"}},
    escape_set(20,es_backward_precise{ep_maximum},tl_glob{EXITT},FNSET),
    set_member(FNSET,tl_glob{root{glob{FN}}}),
    cil_sum_body(FN,s_func)->sum_bound(_,_,EXITP),
    +attribute_receive("elv_fs_entry",AT,FN,s_func,EXITP,drf{root{arg{0}}}).
+ignore_escape_function("elv_register").
+ignore_escape_function("elv_unregister").
