% baked-in information about safe types etc.
% imported directly by typeuse.clp

predicate check_subtype_shared(list[string]).
check_subtype_shared(LIST), list_mem(LIST,C0), list_mem(LIST,C1), C0\=C1,
    +check_subtype(y_comp{C0},y_comp{C1}).

% linux

% dma_addr_t is an unsigned integer that represents a pointer
+check_cast_typedef("dma_addr_t",y_ptr{_}).

% these are casts that have been hand inspected and determined to be
% intentional behavior whose invariants we can't yet capture,
% mostly non-homogenous recursive structures

+check_subtype_shared(["sk_buff","sk_buff_head","skb_shared_info"]).

% radix tree style structures
+check_subtype(_,y_comp{"idr_layer"}).
+check_subtype(_,y_comp{"radix_tree_node"}).

% freelist structures, may overlay one another
+check_subtype(y_comp{"slab_rcu"},y_comp{"slab"}).

% annotations for misc type-unsafe structs

% bsd sockets. this is nasty
check_subtype(y_comp{C0},y_comp{C1}) :-
    (str_sub(C0,_,_,"sockaddr"); C0="sctp_addr"),
    (str_sub(C1,_,_,"sockaddr"); C1="sctp_addr").

% fake structure used for copy to/from user
+check_subtype(_,y_comp{"__large_struct"}).

% JFS structures
+check_subtype(y_comp{"ldtentry"},y_comp{"dtslot"}).
+check_subtype(y_comp{"idtentry"},y_comp{"dtslot"}).
+check_subtype(y_comp{"__anonunion_dtpage_t_193"},y_comp{"__anonunion_dtroot_t_145"}).

% other assorted stuff
+check_subtype(_,y_comp{"_MPT_FRAME_HDR"}).
+check_subtype(y_comp{"acpi_operand_object"},y_comp{"acpi_namespace_node"}).
+check_subtype(y_comp{"ifreq"},y_comp{"if_irda_req"}).
