% baked in behavior for particular targets which have been checked by hand but not automated

predicate ignore_value(in HKL:h_kind_loc,in T:t_trace,in C:string).
trivial_property(l_value{T,C,_},_,HC,no) :-
    curloc(HKL), ignore_value(HKL,T,C), trace_string(T,TS),
    HC = hc_true{no,"Type/value "^C^" ignored for "^TS}.

predicate ignore_call(in FN:string,in SUM:sum,in I:sum).
method_check(hk_prior_inst{I,_,_,_},hm_trivial,HC) :-
    cursum(FN,SUM), ignore_call(FN,SUM,I),
    HC = hc_true{no,"Call ignored for "^FN}.

% sk_buff

% sk_buff allocation - space is always allocated at sk_buff->end
% for an skb_shared_info. proving this is kind of hit or miss as sometimes
% the relevant functions timeout.
+ignore_value(hl_comp{"sk_buff"},drf{fld{empty,"end","sk_buff"}},"skb_shared_info").

% net_device

% weird case with device's hard_start_xmit stored in another structure
ignore_callgraph_site("net/atm/mpc.c:mpc_send_packet",I,_) :-
    ~cil_sum_body("net/atm/mpc.c:mpc_send_packet",s_func)->dircall(I,_).

% ditto, set_mac_address pointer stored in global variable
ignore_callgraph_site("net/atm/br2684.c:br2684_mac_addr",I,_) :-
    ~cil_sum_body("net/atm/br2684.c:br2684_mac_addr",s_func)->dircall(I,_).

% device

% unhandled equality tests comparing client->driver
+ignore_value(hl_func{"i2c_del_driver",_},drf{fld{_,"driver_data","device"}},_).
+ignore_value(hl_func{"i2c_isa_del_driver",_},drf{fld{_,"driver_data","device"}},_).

% Qdisc

% weird allocation for this structure, indicated by priv_size within Qdisc_ops.
% do not have a way to cover this precisely (as with e.g. net_device).
+ignore_value(hl_func{"qdisc_alloc",_},fld{_,"$Qdisc$160",_},_).
