% baked in analysis behavior

% ASSEMBLY (UNKNOWN INITIALIZERS)

predicate fn_break(in FN:string,in TS:string).
handle(T) :- cil_curfn(FN), trace_string(T,TS), fn_break(FN,TS).

+fn_break("console_init","call**").
+fn_break("efi_enter_virtual_mode","efi.systab*.runtime*.get_next_variable*").
+fn_break("efi_enter_virtual_mode","efi.systab*.runtime*.get_time*").
+fn_break("efi_enter_virtual_mode","efi.systab*.runtime*.get_variable*").
+fn_break("efi_enter_virtual_mode","efi.systab*.runtime*.reset_system*").
+fn_break("efi_enter_virtual_mode","efi.systab*.runtime*.set_variable*").
+fn_break("efi_init","runtime*.get_time*").
+fn_break("init/main.c:do_initcalls","call**").
+fn_break("machine_kexec","reboot_code_buffer*").
+fn_break("security/security.c:do_security_initcalls","call**").

% POLYMORPHIC VOID*

predicate fn_ref(in FN:string,in TS:string,Y:t_loc).
handle_ref(T,Y) :- cil_curfn(FN), trace_string(T,TS), fn_ref(FN,TS,Y).

+fn_ref("drivers/block/paride/pd.c:pd_special",
         "drivers/block/paride/pd.c:pd_req*.special*",
         yl_func_arg{"drivers/block/paride/pd.c:pd_special_command",1}).

fn_ref(FN,"__arg1*.arg*",yl_target{CFN}) :-
    (FN="drivers/char/ipmi/ipmi_watchdog.c:get_param_str";
     FN="drivers/char/ipmi/ipmi_watchdog.c:set_param_str"),
    (CFN="drivers/char/ipmi/ipmi_watchdog.c:action_op";
     CFN="drivers/char/ipmi/ipmi_watchdog.c:preaction_op";
     CFN="drivers/char/ipmi/ipmi_watchdog.c:preop_op").

fn_ref("drivers/usb/serial/visor.c:visor_probe",
       "__arg1*.driver_info*",yl_target{CFN}) :-
    (CFN="drivers/usb/serial/visor.c:palm_os_3_probe";
     CFN="drivers/usb/serial/visor.c:palm_os_4_probe").

fn_ref("fs/afs/cmservice.c:kafscmd",
       "call*.app_user*",yl_target{CFN}) :-
    (CFN="fs/afs/cmservice.c:kafscmd:_SRXAFSCM_CallBack";
     CFN="fs/afs/cmservice.c:kafscmd:_SRXAFSCM_InitCallBackState";
     CFN="fs/afs/cmservice.c:kafscmd:_SRXAFSCM_Probe").

fn_ref(FN,TS,yl_comp{"sock","data_ready"}) :-
    (FN="fs/ocfs2/cluster/tcp.c:o2net_listen_data_ready", TS="__arg0*.sk_user_data*";
     FN="fs/ocfs2/cluster/tcp.c:o2net_register_callbacks", TS="__arg0*.sk_user_data*";
     FN="o2net_stop_listening", TS="sock*.sk*.sk_user_data*").

+fn_ref("net/ipv6/route.c:fib6_dump_end","__arg0*.args*",
         yl_comp{"netlink_callback","done"}).

+fn_ref("fs/reiserfs/procfs.c:r_show","de*.data*",
         yl_func_arg{"fs/reiserfs/procfs.c:add_file",2}).

+fn_ref("smb_newconn","tmp.__xchg*",yl_comp{"sock","sk_data_ready"}).
+fn_ref("smb_newconn","sk*.sk_data_ready*",yl_target{"smb_data_ready"}).

% SINGLE TYPE VOID*

+handle_type(drf{fld{_,"callback","_diva_didd_adapter_notify"}}).
+handle_type(drf{fld{_,"Handler","irq_req_t"}}).
+handle_type(drf{fld{_,"data_ready","smb_sb_info"}}).

predicate fn_type(in FN:string,in TS:string).
handle_type(T) :- cil_curfn(FN), trace_string(T,TS), fn_type(FN,TS).

+fn_type("drivers/net/wan/hdlc_ppp.c:ppp_open","old_ioctl*").
+fn_type("hdlc_raw_eth_ioctl","old_ch_mtu*").
+fn_type("drivers/scsi/qla2xxx/qla_os.c:qla2x00_start_timer","__arg1*").
+fn_type("sound/pci/als300.c:snd_als300_create","irq_handler*").

predicate any_type(in TS:string).
handle_type(T) :- trace_string(T,TS), any_type(TS).

+any_type("drivers/scsi/dc395x.c:dc395x_scsi_phase0*").
+any_type("drivers/scsi/dc395x.c:dc395x_scsi_phase1*").
+any_type("drivers/scsi/tmscsim.c:dc390_phase0*").
+any_type("drivers/scsi/tmscsim.c:dc390_phase1*").

% NON-STATIC FNPTR ARRAYS

+fn_ref("FsmEvent","__arg0*.fsm*.jumpmatrix**",yl_comp{"FsmNode","routine"}).

predicate fn_table(FN:string,TS:string,COMP:string,FLD:string).
fn_ref(FN,TS,yl_glob{GLOB}) :- fn_table(FN,TS,COMP,FLD),
    sum_init_assign_field(COMP,FLD)->funptr_assign(_,root{glob{GLOB}}).
handle(drf{root{glob{GLOB}}}) :-
    cil_init(_), assign(p_abort,fld{_,FLD,COMP},s_trace{root{glob{GLOB}}},_),
    fn_table(_,_,COMP,FLD).

% in case sum_init_assign_field has not been filled in yet
fn_break(FN,TS) :- fn_table(FN,TS,_,_).

+fn_table("net/core/wireless.c:call_commit_handler",
          "__arg0*.wireless_handlers*.standard**",
          "iw_handler_def","standard").
+fn_table("net/core/wireless.c:get_handler",
          "__arg0*.wireless_handlers*.private**",
          "iw_handler_def","private").
+fn_table("net/core/wireless.c:get_handler",
          "__arg0*.wireless_handlers*.standard**",
          "iw_handler_def","standard").

+fn_table("net/llc/llc_conn.c:llc_exec_conn_trans_actions","next_action**",
          "llc_conn_state_trans","ev_actions").
+fn_table("net/llc/llc_conn.c:llc_qualify_conn_ev","next_qualifier**",
          "llc_conn_state_trans","ev_qualifiers").
+fn_table("net/llc/llc_sap.c:llc_exec_sap_trans_actions","next_action**",
          "llc_sap_state_trans","ev_actions").
+fn_table("net/llc/llc_station.c:llc_exec_station_trans_actions","next_action**",
          "llc_station_state_trans","ev_actions").

% FLOW SENSITIVITY ISSUES

+fn_break("drivers/ieee1394/ieee1394_core.c:hpsbpkt_thread","packet*.complete_data*").
+fn_break("fs/ocfs2/cluster/tcp.c:o2net_register_callbacks","__arg1*").

% BUGS

+fn_break("fs/coda/dir.c:coda_readdir","__arg1*").

% MISC

+fn_ref("mm/swap.c:put_compound_page","__arg0*.lru.next*",
        yl_target{"mm/page_alloc.c:free_compound_page"}).

fn_ref("drivers/mtd/devices/docprobe.c:DoC_Probe",
        "tmp.inter_module_get_request*",yl_target{CFN}) :-
    (CFN="drivers/mtd/devices/doc2000.c:DoC2k_init";
     CFN="drivers/mtd/devices/doc2001plus.c:DoCMilPlus_init").
