(* Conversion of CLPA AST values into ML form *)

val reset : unit -> unit

val cil_of_clpa_constant : Spec.t_val -> Cil.constant
val cil_of_clpa_exp : Spec.t_val -> Cil.exp
val cil_of_clpa_type : Spec.t_pred option -> Spec.t_val -> Cil.typ
val cil_of_clpa_comp : string -> Cil.compinfo
val cil_of_clpa_fieldinfo_comp : Cil.compinfo -> Spec.t_val -> Cil.fieldinfo
val cil_of_clpa_lval : Spec.t_val -> Cil.lval
val cil_of_clpa_offset : Cil.typ -> Spec.t_val -> Cil.offset
val cil_of_clpa_global_var : string -> Cil.varinfo
val cil_of_clpa_varinfo : Spec.t_pred option -> Spec.t_val -> Cil.varinfo
val cil_of_clpa_fundec : string option -> Cil.fundec
val cil_of_clpa_instr : Spec.t_val -> Cil.instr

val unknown_loc: Cil.location

val get_enuminfo_by_name : string -> Cil.enuminfo
val get_varinfo_by_name : string -> Cil.varinfo
