(* Unique ID counter abstraction.
 *
 * This module provides functions to hand out consecutively numbered integers.
 * By introducing an abstraction barrier, we remove any chance of confusion
 * as to whether the value stored is the last number or the next number
 * to be handed out. *)

type t

(* "init n" returns a counter whose first allocation will be the integer n *)
val init : int -> t

(* "allocate" returns the next value of the counter *)
val allocate : t -> int
